﻿using System.Collections;
using System.Collections.Generic;
using UnityEngine;

public class Grenade : MonoBehaviour
{
    [SerializeField]
    AnimationCurve moveCurve;
    [SerializeField]
    AnimationCurve sizeCurve;

    private Vector3 destination;
    private float explosionTime = 2;
    private float explosionTimer = 2;

    private float explosionRadius = 3;

    [SerializeField]
    private ParticleSystem explosionParticle;

    private Vector3 startPosition;

    private TrailRenderer trail;
    private float trailWidth;
    public void Init(Vector3 destination, float explosionRadius, float explosionTime = 2)
    {
        this.destination = destination;
        this.explosionRadius = explosionRadius;
        this.explosionTime = explosionTimer = explosionTime;
        startPosition = transform.position;
        trail = GetComponent<TrailRenderer>();
    }

    private void Update()
    {
        transform.position = Vector2.Lerp(startPosition, destination, moveCurve.Evaluate((explosionTime - explosionTimer) / explosionTime));
        transform.localScale = Vector3.one * sizeCurve.Evaluate((explosionTime - explosionTimer) / explosionTime);
        //trail.widthCurve.keys[0].value = trailWidth * sizeCurve.Evaluate((explosionTime - explosionTimer) / explosionTime);
        explosionTimer -= Time.deltaTime;
        if (explosionTimer < 0)
        {
            Explode();
        }
    }

    private void Explode()
    {
        Instantiate(explosionParticle, transform.position, Quaternion.identity).Play();
        Destroy(gameObject);
    }
}
